Subject: PCI init vs. memory init

From: [email-masked] (Linas Vepstas)
Date: Fri, 28 Apr 2006 18:04:01 -0500

Paul,

I'd previously reported a problem where the PCI subsystem 
was getting inited before the memory subsystem. In the unusual
case of an EEH failure, this resulted in a crash in kmalloc,
which I hacked around with a if(!mem_init_done).

You mentioned that the sequence of inits seemed wrong, that the 
PCI init should be done later, after the memory init. I think
I agree; but when I took a very very quick look at the code, there 
was no obvious hook in later init to move the PCI init over to. 

Are you pursuing this further? Should I dig into it?  Any bright
ideas? Am I missing something obvious?  

There are several spots in in the powerpc PCI init code where 
a boot_mem alloc is used instead of kmalloc, and this boot_mem is 
then hacked around in the case of a PCI hotplug remove.  It would 
be nice to fix this...

--linas